
/*! \file
* Copyright (c) 2008
* Project : Base
* File    : Font Header (Independent)
* Author  : Dave Reed
*/

/*-Include-Once--------------------------------------------------------------*/

#if !defined(__BASE_FONT_H__)
#define __BASE_FONT_H__ /*!< \brief Include once define. */

/*-Project-Includes----------------------------------------------------------*/

#include "Base/Texture.h"
#include "Base/Blitter.h"

// Alignment defines
#define	ALIGN_LEFT    0x00
#define ALIGN_RIGHT   0x01
#define ALIGN_CENTRE  0x02

#define	ALIGN_TOP	  0x00
#define ALIGN_BOTTOM  0x10
#define ALIGN_MIDDLE  0x20


struct FontChar
{
	bool  m_bValid;
	float m_afU[2];
	float m_afV[2];
	float m_fWidth;
	float m_fHeight;
	float m_fxOffset;
	float m_fyOffset;
	float m_fxAdvance;
};


class Font
{	
public:		

	// Constructor
	Font(char *szName, float fExtraSpacing=0, float fExtraSpaceWidth=-1);
	~Font();

	float   GetStringLength(char *szString, float fScale);
	void    PrintString(char *szString, float fX, float fY, int iFlags = 0, uint32 uColor = 0xffffffff, float fScale = 1.0f);
	
private:
	// Font textures
	Texture *m_apxFontTextures[2];

	// Font characters
	FontChar m_axChars[256];

	// Font properties
	int      m_iNumChars;
	float    m_fLineHeight;
	float    m_fBaseHeight;
};



#endif  // __BASE_FONT_H__