
/*! \file
* Copyright (c) 2008
* Project : Base
* File    : Input Source (Independent)
* Author  : Dave Reed
*/

/*-Project-Includes----------------------------------------------------------*/

#include "Main.h"
#include "Base/Input.h"
#include "Base/Render.h"
#include "Platform_Input.h"

bool Input::s_abActions[NUM_ACTIONS];
bool Input::s_abPrevActions[NUM_ACTIONS];

int  Input::s_iMouseX		= 0;
int  Input::s_iMouseY		= 0;
int  Input::s_iMouseB		= 0;
int  Input::s_iPrevMouseB	= 0;
bool Input::s_bMouseValid   = false;

void Input::Initialize()
{
	for(int i=0; i<NUM_ACTIONS; i++)
	{
		s_abPrevActions[i] = s_abActions[i] = false;
	}

	Platform_Initialize();
}

void Input::Shutdown()
{
	Platform_Shutdown();
}

void Input::Update()
{
	for(int i=0; i<NUM_ACTIONS; i++)
	{
		s_abPrevActions[i] = s_abActions[i];
	}

	Platform_Update();
}


bool Input::ActionHeld(BASE_ACTION eAction)
{
	return s_abActions[eAction];
}


bool Input::ActionPressed(BASE_ACTION eAction)
{
	return (s_abActions[eAction] && !s_abPrevActions[eAction]);
}


float Input::MouseX()
{
	float fX = (float)s_iMouseX;
	return (fX/((float)Render::GetScreenWidth())) * Render::Get2DScreenRightX();
}

float Input::MouseY()
{
	float fY = (float)s_iMouseY;
	return (fY/((float)Render::GetScreenHeight())) * Render::Get2DScreenBottomY();
}