/*! \file
* Copyright (c) 2008
* Project : Base
* File    : Platform_Blitter Source (Windows)
* Author  : Dave Reed
*/

/*-Project-Includes----------------------------------------------------------*/

#include "Main.h"
#include "Platform_Blitter.h"
#include "Platform_Shaders.h"

/*-Classes-------------------------------------------------------------------*/


void Blitter2D::Platform_RenderLines(int iCount)
{	
	Platform_Shaders::Begin(SHADER_BLITTER2D);
	Platform_Render::GetD3DDevice()->DrawPrimitiveUP(D3DPT_LINELIST , iCount, s_axLineVerts, sizeof(Vertex2D));
	Platform_Shaders::End();
}


void Blitter2D::Platform_BlitRects(int iCount, SHADER eShader)
{
	Platform_Shaders::Begin(eShader);
	Platform_Render::GetD3DDevice()->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST ,0 , iCount*4, iCount*2, s_aiIndices, D3DFMT_INDEX32, s_axVerts, sizeof(Vertex2D));
	Platform_Shaders::End();
}


void Blitter3D::Platform_RenderLines(int iCount)
{	
	Platform_Shaders::Begin(SHADER_BLITTER3D);
	Platform_Render::GetD3DDevice()->DrawPrimitiveUP(D3DPT_LINELIST , iCount, s_axLineVerts, sizeof(Vertex3D));
	Platform_Shaders::End();
}


void Blitter3D::Platform_BlitQuads(int iCount, SHADER eShader)
{
	Platform_Shaders::Begin(eShader);
	Platform_Render::GetD3DDevice()->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST ,0 , iCount*4, iCount*2, s_aiIndices, D3DFMT_INDEX32, s_axVerts, sizeof(Vertex3D));
	Platform_Shaders::End();
}