
/*! \file
* Copyright (c) 2008
* Project : Base
* File    : Texture Header (PC)
* Author  : Dave Reed
*/

/*-Include-Once--------------------------------------------------------------*/

#if !defined(__BASE_PLATFORM_TEXTURE_H__)
#define __BASE_PLATFORM_TEXTURE_H__ 

#include "Base/Texture.h"

/*-Classes-------------------------------------------------------------------*/

class Texture;


class Platform_Texture
{
public:
	static bool Load(Texture *pTex, bool bMipMaps);
	static void CreateRenderTarget(Texture *pTex);

	static void Flush(Texture *pTex);

	static void PreReset(Texture *pTex);
	static void PostReset(Texture *pTex);

	static void BeginScene(Texture *pTex);
	static void EndScene(Texture *pTex);

	Platform_Texture()
	{
		m_pD3DTexture = NULL;
	}

	IDirect3DTexture9 *m_pD3DTexture;
};



#endif // __BASE_PLATFORM_TEXTURE_H__ 