
/*! \file
* Copyright (c) 2008
* Project : Base
* File    : TiXmlUtil Source (Independent)
* Author  : Dave Reed
*/

/*-Project-Includes----------------------------------------------------------*/

#include "Main.h"
#include "Base/TiXmlUtil.h"



float TiXmlUtil::GetFloat(TiXmlElement *pxElt,  char *szAttrib, float fDefault)
{
	float fVal;
	if (TIXML_SUCCESS == pxElt->QueryFloatAttribute(szAttrib, &fVal))
		return fVal;
	else
		return fDefault;
}


uint32 TiXmlUtil::GetUInt(TiXmlElement *pxElt,   char *szAttrib, uint32 uDefault)
{
	char *szString = const_cast<char *>(pxElt->Attribute(szAttrib));
	
	if (szString)
	{
		return (uint32)atol(szString);
	}
	else
	{
		return uDefault;
	}
}


int TiXmlUtil::GetInt(TiXmlElement *pxElt,    char *szAttrib, int iDefault)
{
	int iVal;
	if (TIXML_SUCCESS == pxElt->QueryIntAttribute(szAttrib, &iVal))
		return iVal;
	else
		return iDefault;
}

bool TiXmlUtil::GetBool(TiXmlElement *pxElt,    char *szAttrib, bool bDefault)
{
	char *szString = const_cast<char *>(pxElt->Attribute(szAttrib));

	if (szString)
	{
		if (_stricmp(szString,"True")==0) return true;
		if (_stricmp(szString,"False")==0) return false;
	}

	return bDefault;
}

char *TiXmlUtil::GetString(TiXmlElement *pxElt, char *szAttrib, char *szDefault)
{
	char *szString = const_cast<char *>(pxElt->Attribute(szAttrib));
	return szString?szString:szDefault;
}


char *TiXmlUtil::GetFileName(TiXmlElement *pxElt, char *szDefault)
{
	char *szString = const_cast<char *>(pxElt->Attribute("rel"));
	return szString?szString:szDefault;
}


