
/*! \file
* Copyright (c) 2008
* Project : Base
* File    : Viewport Source (Independent)
* Author  : Dave Reed
*/

/*-Project-Includes----------------------------------------------------------*/

#include "Main.h"
#include "Base/Viewport.h"
#include "Platform_Render.h"

/*-Class-Public-Functions----------------------------------------------------*/


void Viewport::Set(int iOriginX, int iOriginY, int iWidth, int iHeight)
{
	m_iOriginX  = iOriginX;
	m_iOriginY  = iOriginY;
	m_iWidth	= iWidth;
	m_iHeight	= iHeight;
}


void Viewport::Set(Viewport &rxViewport)
{
	Platform_Render::SetViewport(&rxViewport);
}

void Viewport::SetDefault()
{
	Platform_Render::SetViewport(NULL);
}


void Viewport::Clear(uint32 uClearARGB, bool bClearColour, bool bClearDepth, bool bClearStencil)
{
	Platform_Render::ClearViewport(uClearARGB, bClearColour, bClearDepth, bClearStencil);
}


