/*! \file
* Copyright (c) 2008
* Project : Base
* File    : Viewport Header (Independent)
* Author  : Dave Reed
*/

/*-Include-Once--------------------------------------------------------------*/

#if !defined(__BASE_VIEWPORT_H__)
#define __BASE_VIEWPORT_H__ /*!< \brief Include once define. */

#include "Base/Viewport.h"
#include "Base/Camera.h"

/*-Classes-------------------------------------------------------------------*/

class Viewport
{
public:
	void Set(int iOriginX, int iOriginY, int iWidth, int iHeight);
	
	int  GetWidth(void)		{ return m_iWidth;   }
	int  GetHeight(void)	{ return m_iHeight;  }
	int  GetOriginX(void)	{ return m_iOriginX; }
	int  GetOriginY(void)	{ return m_iOriginY; }

	static void Set(Viewport &rxViewport);
	static void SetDefault();
	static void Clear(unsigned int uClearARGB, bool bClearColour = true, bool bClearDepth = true, bool bClearStencil = true);

private:
	int m_iOriginX;
	int m_iOriginY;
	int m_iWidth;
	int m_iHeight;
};


#endif  // __BASE_VIEWPORT_H__
