
/*! \file
* Copyright (c) 2008
* Project : Poopoo Rapido
* File    : Game.cpp
* Author  : Dave Reed
*/

/*-Include-Once--------------------------------------------------------------*/

#if !defined(__GAME_H__)
#define __GAME_H__ /*!< \brief Include once define. */

#include "Base/Font.h"
#include "Track.h"

/*-Project-Includes----------------------------------------------------------*/

enum
{
	COLLISION_TYPE_WORLD = 0,
	COLLISION_TYPE_PLAYER,
	COLLISION_TYPE_PRIMARYDUNGBALL,	
	COLLISION_TYPE_COLLECTABLEDUNGBALL,	
	COLLISION_TYPE_MOVEABLE
};


enum 
{
	GAMESTATE_TRACKSELECT = 0,
	GAMESTATE_PLAYING,
};

class Game
{
public:
	static void Initialize(void);
	static void UpdateAndRender(float fTimeStep);
	static void Shutdown(void);
	static void Start(void);
	static void ResetPhysics(void);
	static void StartRace(void);

	static void LoadBestTimes(void);
	static void SaveBestTimes(void);

	static Font  *m_pMainFont;
	static Track  m_Track;
	static neSimulator *m_pSimulator;

	static int m_eGameState;
};


#endif // __GAME_H__
