

#ifndef __RECORD_H__
#define __RECORD_H__

class RecordFrame
{
public:

	float  fTime;	
	Matrix xPosOrient;
};


class RecordBuffer
{
public:

	RecordBuffer(int iMaxFrames)
	{
		iMaxNumFrames = iMaxFrames;
		iNumFrames = 0;
		iLastPos = 0;
		pFrames = new RecordFrame[iMaxNumFrames];
	}

	~RecordBuffer()
	{
		delete [] pFrames;
	}

	void Record(Matrix& xPosOrient, float fTime);
	
	bool Playback(Matrix &xPosOrient, float fTime);

	void Save(int iLevel, int iTrack);
	void Load(int iLevel, int iTrack);
	
	int			 iLastPos;
	int			 iNumFrames;
	int			 iMaxNumFrames;
	RecordFrame *pFrames;

};

#endif