

#include "Main.h"
#include "Base/Render.h"
#include "Sound.h"
#include "fmod.h"


char *aszSFXFiles[SFX_COUNT] =
{
	"Data\\Audio\\MenuBleep.wav",
	"Data\\Audio\\MenuBloop.wav",
	"Data\\Audio\\MenuBuzz.wav",
	"Data\\Audio\\Three.wav",
	"Data\\Audio\\Two.wav",
	"Data\\Audio\\One.wav",
	"Data\\Audio\\Go.wav",
	"Data\\Audio\\Fail.wav",
	"Data\\Audio\\Win.wav",
	"Data\\Audio\\Checkpoint.wav",
	"Data\\Audio\\Landing.wav",
	"",
	"Data\\Audio\\ThrustLoop.wav",
	"Data\\Audio\\BrakeLoop.wav",
	"Data\\Audio\\TurnLoop.wav",
	"Data\\Audio\\TurnLoop.wav",
	"Data\\Audio\\FallLoop.wav"

};

int g_aiChannels[SFX_COUNT];

FSOUND_SAMPLE *g_apSFX[SFX_COUNT];



void Sound::Init(void)
{
	FSOUND_Init(44100, 32, FSOUND_INIT_USEDEFAULTMIDISYNTH);

	for(int i=0; i<SFX_COUNT; i++)
	{
		g_apSFX[i] = NULL;

		g_apSFX[i] = FSOUND_Sample_Load(FSOUND_UNMANAGED, aszSFXFiles[i], FSOUND_NORMAL | FSOUND_HW2D, 0, 0);

		if (i>=SFX_FIRSTLOOPING && i!=SFX_BRAKELOOP && i!=SFX_FALLLOOP && i!=SFX_THRUSTLOOP)
			FSOUND_Sample_SetMode(g_apSFX[i], FSOUND_LOOP_NORMAL);		
		else
			FSOUND_Sample_SetMode(g_apSFX[i], FSOUND_LOOP_OFF);		

		g_aiChannels[i] = -1;
	}
}


void Sound::Play(int iSound)
{
	if (iSound<SFX_FIRSTLOOPING)
	{
		FSOUND_PlaySound(FSOUND_FREE, g_apSFX[iSound]);
	}
	else
	{
		if (g_aiChannels[iSound]<0)
		{
			g_aiChannels[iSound] = FSOUND_PlaySound(FSOUND_FREE, g_apSFX[iSound]);
		}
	}
}


void Sound::Stop(int iSound)
{
	if (g_aiChannels[iSound]>=0)
	{
		FSOUND_StopSound(g_aiChannels[iSound]);
		g_aiChannels[iSound] =-1;		
	}
}

void Sound::STFU(void)
{
	for(int i=0; i<SFX_COUNT; i++)
	{
		Sound::Stop(i);
	}
}